<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    <script>
        const data = [{
            id: 1,
            name: '家电',
            goods: [{
                id: 3,
                name: '洗衣机'
            }, {
                id: 4,
                name: '冰箱'
            }]
        }, {
            id: 2,
            name: '服装'
        }]

        function search_goods(data, id) {
            var obj = {}
            data.forEach( item => {
                if (item.id === id ) {
                    // console.log(item.name);
                    o = item
                } else if (item.goods && item.goods.length != 0) {
                    o = search_goods(item.goods, id)
                }
            })
        }
        search_goods(data, 4)
        search_goods(data, 1)
    </script>
</body>
</html>